function bars = GenerateRandomBars2(t, c, acc, tn, n)

assert(tn>1);

[~,y]=hist(diff(t),10000);
tscale = y(1);

cdiffs = nan(numel(t),1);

for i = 2:numel(t)
   
    if t(i)-t(i-1) > tscale
        continue;
    end
    
    cdiffs(i) = (c(i)-c(i-1))/c(i-1);
    
end

cdiffs(isnan(cdiffs)) = [];

[x,y] = hist(cdiffs,10000);

wmean = sum(x.*y)/sum(x);

fprintf('Weighted mean / mean(cdiffs) ratio: %g\n', wmean / mean(cdiffs));

ro = nan(n,1); rh = nan(n,1); rl = nan(n,1); rc = nan(n,1);

prevclose = 1;

rwsum = 0;
nrw = 0;

for i = 1:n

    rw = GenerateRandomWalk(y,x,tn-1);
    rwsum = rwsum + sum(rw);
    nrw = nrw + numel(rw);
    rw = cumprod(1+rw);
    
    ro(i) = prevclose * rw(1);
    rc(i) = prevclose * rw(end);
    rh(i) = prevclose * max(rw);
    rl(i) = prevclose * min(rw);
   
    prevclose = rc(i);
    
end

rwmean = rwsum/nrw;

fprintf('Random walk mean / mean(cdiffs) ratio: %g\n', rwmean / mean(cdiffs));

bars = struct('o', ro, 'h', rh, 'l', rl, 'c', rc);











